import marimo

__generated_with = "0.11.23"
app = marimo.App(width="medium")


@app.cell
def _(
    E_a_number,
    E_e_number,
    E_f_number,
    E_i_number,
    V_checkbox,
    Vae,
    Vaf,
    Vai,
    Vea,
    Vef,
    Vei,
    Vfa,
    Vfe,
    Vfi,
    Via,
    Vie,
    Vif,
    c0_contour,
    c0_plot_checkbox,
    c0_surface,
    c1_contour,
    c1_plot_checkbox,
    c1_surface,
    c2_contour,
    c2_plot_checkbox,
    c2_surface,
    c3_contour,
    c3_plot_checkbox,
    c3_surface,
    d_number,
    degConct,
    degCoupl,
    export_button,
    filename_text_input,
    k_p_checkbox,
    k_q_checkbox,
    kpa,
    kpe,
    kpf,
    kpi,
    kqa,
    kqe,
    kqf,
    kqi,
    mo,
    pub_fig_checkbox,
    theta_p_number,
    theta_q_number,
    z0_cutoff_slider,
    z1_cutoff_slider,
    z2_cutoff_slider,
    z3_cutoff_slider,
):
    # this cell handles the output

    mo.md(f'''
    <table style="width:100%">
        <tr>
            <td>{V_checkbox}</td>
            <td></td>
            <td>{k_q_checkbox} all k<sub>q</sub> equal</td>
            <td>{k_p_checkbox} all k<sub>p</sub> equal</td>
        </tr>
        <tr>
            <td>{d_number}</td>
            <td>{E_i_number}</td>
            <td>{kqi}</td>
            <td>{kpi}</td>
        </tr>
        <tr>
            <td>{theta_q_number}</td>
            <td>{E_e_number}</td>
            <td>{kqe}</td>
            <td>{kpe}</td>
        </tr>
        <tr>
            <td>{theta_p_number}</td>
            <td>{E_a_number}</td>
            <td>{kqa}</td>
            <td>{kpa}</td>
        </tr>
        <tr>
            <td></td>
            <td>{E_f_number}</td>
            <td>{kqf}</td>
            <td>{kpf}</td>
            <td></td>
        </tr>
        <tr>
            <td colspan="4"><hr/></td>
        </tr>
        <tr>
            <td style="text-align: center;">0</td>
            <td>{Vei}</td>
            <td>{Vai}</td>
            <td>{Vfi}</td>
        </tr>
        <tr>
        <td>{Vie}</td>
            <td style="text-align: center;">0</td>
            <td>{Vae}</td>
            <td>{Vfe}</td>
        </tr>
        <tr>
            <td>{Via}</td>
            <td>{Vea}</td>
            <td style="text-align: center;">0</td>
            <td>{Vfa}</td>
        </tr>
            <tr>
            <td>{Vif}</td>
            <td>{Vef}</td>
            <td>{Vaf}</td>
            <td style="text-align: center;">0</td>
        </tr>
        <tr>
            <td colspan="4"><hr/></td>
        </tr>
            <tr>
            <td style="text-align: center"> Degree of coupling: </td>
            <td style="text-align: center">{degCoupl:.3f}</td>
        </tr>
        <tr>
            <td style="text-align: center"> Degree of concertedness: </td>
            <td style="text-align: center">{degConct:.3f}</td>
        </tr>
        <tr>
            <td colspan="4"><hr/></td>
        </tr>
        </table>

    <table style="width:100%">
      <tr>
      <td> Surface </td>
      <td>{pub_fig_checkbox}</td>
      <td></td>
      <td> Z-scale slider</td>
      </tr>
        <tr>
          <td>{c3_plot_checkbox}</td>
          <td>{mo.as_html(c3_surface) if c3_plot_checkbox.value else ""}</td>
          <td>{mo.as_html(c3_contour) if c3_plot_checkbox.value else ""}</td>
          <td>{z3_cutoff_slider if c3_plot_checkbox.value else ""}</td>
        </tr>
        <tr>
          <td>{c2_plot_checkbox}</td>
          <td>{mo.as_html(c2_surface) if c2_plot_checkbox.value else ""}</td>
          <td>{mo.as_html(c2_contour) if c2_plot_checkbox.value else ""}</td>
          <td>{z2_cutoff_slider if c2_plot_checkbox.value else ""}</td>
        </tr>
        <tr>
          <td>{c1_plot_checkbox}</td>
          <td>{mo.as_html(c1_surface) if c1_plot_checkbox.value else ""}</td>
          <td>{mo.as_html(c1_contour) if c1_plot_checkbox.value else ""}</td>
          <td>{z1_cutoff_slider if c1_plot_checkbox.value else ""}</td>
        </tr>
        <tr>
          <td>{c0_plot_checkbox}</td>
          <td>{mo.as_html(c0_surface) if c0_plot_checkbox.value else ""}</td>
          <td>{mo.as_html(c0_contour) if c0_plot_checkbox.value else ""}</td>
          <td>{z0_cutoff_slider if c0_plot_checkbox.value else ""}</td>
        </tr>
    </table>
    {filename_text_input}{export_button}
    ''')
    return


@app.cell
def _():
    import marimo as mo
    from PCETmodel import PCET_model
    import numpy as np

    # this sets up the textboxes...
    d_number = mo.ui.number(start=0, value = 1, label="d")

    theta_q_number = mo.ui.number(start=1, stop = 89, value = 45, label=r"&#920<sub>qi</sub>")
    theta_p_number = mo.ui.number(start=1, stop = 89, value = 45, label=r"&#920<sub>pi</sub>")

    E_i_number = mo.ui.number(start=0, value = 0, label=r"E<sub>i</sub>")
    E_e_number = mo.ui.number(start=0, value = 2, label=r"E<sub>e</sub>") # figure out a good guess for this
    E_a_number = mo.ui.number(start=0, value = 2, label=r"E<sub>a</sub>") # figure out a good guess for this
    E_f_number = mo.ui.number(start=0, value = 0, label=r"E<sub>f</sub>")

    k_p_checkbox = mo.ui.checkbox(value=True)
    k_q_checkbox = mo.ui.checkbox(value=True)

    k_iq_number = mo.ui.number(start=0, value = 36, label=r"k<sub>iq</sub>") # rough guess, based on Adam's comments 
    k_ip_number = mo.ui.number(start=0, value = 42, label=r"k<sub>ip</sub>") # rough guess, based on Adam's comments

    k_eq_number = mo.ui.number(start=0, value = 36, label=r"k<sub>eq</sub>") # rough guess, based on Adam's comments 
    k_ep_number = mo.ui.number(start=0, value = 42, label=r"k<sub>ep</sub>") # rough guess, based on Adam's comments

    k_aq_number = mo.ui.number(start=0, value = 36, label=r"k<sub>aq</sub>") # rough guess, based on Adam's comments 
    k_ap_number = mo.ui.number(start=0, value = 42, label=r"k<sub>ap</sub>") # rough guess, based on Adam's comments

    k_fq_number = mo.ui.number(start=0, value = 36, label=r"k<sub>fq</sub>") # rough guess, based on Adam's comments 
    k_fp_number = mo.ui.number(start=0, value = 42, label=r"k<sub>fp</sub>") # rough guess, based on Adam's comments

    V_checkbox = mo.ui.checkbox(value=True, label = "donor = acceptor") # specifies if the donor and acceptor are identical

    z3_cutoff_slider = mo.ui.range_slider(0, 100, step = 0.1, show_value=True, orientation = "vertical")
    z2_cutoff_slider = mo.ui.range_slider(0, 100, step = 0.1, show_value=True, orientation = "vertical")
    z1_cutoff_slider = mo.ui.range_slider(0, 100, step = 0.1, show_value=True, orientation = "vertical")
    z0_cutoff_slider = mo.ui.range_slider(0, 100, step = 0.1, show_value=True, orientation = "vertical")

    c3_plot_checkbox = mo.ui.checkbox(label = r"C<sub>3</sub>")
    c2_plot_checkbox = mo.ui.checkbox(label = r"C<sub>2</sub>")
    c1_plot_checkbox = mo.ui.checkbox(label = r"C<sub>1</sub>")
    c0_plot_checkbox = mo.ui.checkbox(label = r"C<sub>0</sub>", value = True)

    filename_text_input = mo.ui.text(value="PCET model state", label="filename")

    pub_fig_checkbox = mo.ui.checkbox(value = False, label= "format for publication")
    return (
        E_a_number,
        E_e_number,
        E_f_number,
        E_i_number,
        PCET_model,
        V_checkbox,
        c0_plot_checkbox,
        c1_plot_checkbox,
        c2_plot_checkbox,
        c3_plot_checkbox,
        d_number,
        filename_text_input,
        k_ap_number,
        k_aq_number,
        k_ep_number,
        k_eq_number,
        k_fp_number,
        k_fq_number,
        k_ip_number,
        k_iq_number,
        k_p_checkbox,
        k_q_checkbox,
        mo,
        np,
        pub_fig_checkbox,
        theta_p_number,
        theta_q_number,
        z0_cutoff_slider,
        z1_cutoff_slider,
        z2_cutoff_slider,
        z3_cutoff_slider,
    )


@app.cell
def _(V_checkbox, mo):
    # create the coupling inputs
    if V_checkbox.value: # this means that the donor and acceptor are identical

        # first, create the coupling elements

        # movement between i and e is electron transfer
        V_ie_number = mo.ui.number(start=0, value = 0.05, label=r"V<sub>ET</sub>") # in eV
        V_ei_number = mo.ui.number(start=0, value = 0.05, label=r"V<sub>ET</sub>") # in eV

        # movement between a and f is electron transfer
        V_af_number = mo.ui.number(start=0, value = 0.05, label=r"V<sub>ET</sub>")
        V_fa_number = mo.ui.number(start=0, value = 0.05, label=r"V<sub>ET</sub>")

        # movement between i and a is proton transfer
        V_ia_number = mo.ui.number(start=0, value = 0.25, label=r"V<sub>PT</sub>") # in eV
        V_ai_number = mo.ui.number(start=0, value = 0.25, label=r"V<sub>PT</sub>") # in eV

        # movement between e and f is proton transfer
        V_ef_number = mo.ui.number(start=0, value = 0.25, label=r"V<sub>PT</sub>")
        V_fe_number = mo.ui.number(start=0, value = 0.25, label=r"V<sub>PT</sub>")

        # movement betwween i and f is PCET
        V_if_number = mo.ui.number(start=0, value = 0, label=r"V<sub>PCET</sub>")
        V_fi_number = mo.ui.number(start=0, value = 0, label=r"V<sub>PCET</sub>")

        # movement between e and a is "charge exchange"
        V_ea_number = mo.ui.number(start=0, value = 0, label=r"V<sub>CE</sub>")
        V_ae_number = mo.ui.number(start=0, value = 0, label=r"V<sub>CE</sub>")

        # and then decide how they are handled

        # i <--> e and f <--> a are ET and share a common V value
        Vie = V_ie_number
        Vei = V_ie_number
        Vaf = V_ie_number
        Vfa = V_ie_number

        # i <--> a and f <--> e are PT and share a common V value
        Via = V_ia_number
        Vai = V_ia_number
        Vef = V_ia_number
        Vfe = V_ia_number

        # i <--> f is PCET
        Vif = V_if_number
        Vfi = V_if_number

        # e <--> a is CE
        Vea = V_ea_number
        Vae = V_ea_number


    else: # this means the donor and acceptor are not the same
        V_ie_number = mo.ui.number(start=0, value = 0.05, label=r"V<sub>ie</sub>") # in eV
        V_ei_number = mo.ui.number(start=0, value = 0.05, label=r"V<sub>ei</sub>") # in eV

        V_ia_number = mo.ui.number(start=0, value = 0.25, label=r"V<sub>ia</sub>") # in eV
        V_ai_number = mo.ui.number(start=0, value = 0.25, label=r"V<sub>ai</sub>") # in eV

        V_if_number = mo.ui.number(start=0, value = 0, label=r"V<sub>if</sub>")
        V_fi_number = mo.ui.number(start=0, value = 0, label=r"V<sub>fi</sub>")

        V_ea_number = mo.ui.number(start=0, value = 0, label=r"V<sub>ea</sub>")
        V_ae_number = mo.ui.number(start=0, value = 0, label=r"V<sub>ae</sub>")

        V_ef_number = mo.ui.number(start=0, value = 0.25, label=r"V<sub>ef</sub>")
        V_fe_number = mo.ui.number(start=0, value = 0.25, label=r"V<sub>fe</sub>")

        V_af_number = mo.ui.number(start=0, value = 0.05, label=r"V<sub>af</sub>")
        V_fa_number = mo.ui.number(start=0, value = 0.05, label=r"V<sub>fa</sub>")

        # but we still think the V-matrix is symmetric so that (for instance) Vie = Vei
        Vie = V_ie_number
        Vei = V_ie_number

        Vef = V_ef_number
        Vfe = V_ef_number

        Via = V_ia_number
        Vai = V_ia_number

        Vaf = V_af_number
        Vfa = V_af_number

        Vif = V_if_number
        Vfi = V_if_number

        Vea = V_ea_number
        Vae = V_ea_number
    return (
        V_ae_number,
        V_af_number,
        V_ai_number,
        V_ea_number,
        V_ef_number,
        V_ei_number,
        V_fa_number,
        V_fe_number,
        V_fi_number,
        V_ia_number,
        V_ie_number,
        V_if_number,
        Vae,
        Vaf,
        Vai,
        Vea,
        Vef,
        Vei,
        Vfa,
        Vfe,
        Vfi,
        Via,
        Vie,
        Vif,
    )


@app.cell
def _(
    k_ap_number,
    k_aq_number,
    k_ep_number,
    k_eq_number,
    k_fp_number,
    k_fq_number,
    k_ip_number,
    k_iq_number,
    k_p_checkbox,
    k_q_checkbox,
):
    # set up things to use for strings...
    if k_q_checkbox.value: #then we want to have symmetric values of k_p
        kqi = k_iq_number
        kqe = k_iq_number
        kqa = k_iq_number
        kqf = k_iq_number
    else:
        kqi = k_iq_number
        kqe = k_eq_number
        kqa = k_aq_number
        kqf = k_fq_number

    if k_p_checkbox.value: #then we want to have symmetric values of k_p
        kpi = k_ip_number
        kpe = k_ip_number
        kpa = k_ip_number
        kpf = k_ip_number
    else:
        kpi = k_ip_number
        kpe = k_ep_number
        kpa = k_ap_number
        kpf = k_fp_number
    return kpa, kpe, kpf, kpi, kqa, kqe, kqf, kqi


@app.cell
def _(myPCET, pub_fig_checkbox):
    # need to separation out the "generate...plot functions, so that they don't trigger when all the other stuff is changed"
    #if c3_plot_checkbox.value:
    c3_surface = myPCET.generate_surface_plot(zs=[myPCET.cs3.z])
    c3_contour = myPCET.generate_contour_plot(zs=[myPCET.cs3.z])

    #if c2_plot_checkbox.value:
    c2_surface = myPCET.generate_surface_plot(zs=[myPCET.cs2.z])
    c2_contour = myPCET.generate_contour_plot(zs=[myPCET.cs2.z])

    #if c1_plot_checkbox.value:
    c1_surface = myPCET.generate_surface_plot(zs=[myPCET.cs1.z])
    c1_contour = myPCET.generate_contour_plot(zs=[myPCET.cs1.z])

    #if c0_plot_checkbox.value:
    c0_surface = myPCET.generate_surface_plot(zs=[myPCET.cs0.z])
    c0_contour = myPCET.generate_contour_plot(zs=[myPCET.cs0.z])

    for plot in [c0_contour, c1_contour, c2_contour, c3_contour]:
        if pub_fig_checkbox.value:
            plot.update_xaxes(ticklen = 15, tickwidth = 3, linewidth = 3, mirror = True)
            plot.update_yaxes(ticklen = 15, tickwidth = 3, linewidth = 3, mirror = True)
            plot.update_layout(
                width = 300*3.3, height = 300*3.3, 
                font = dict(size=33), # based in 300 dpi
                )
        else:
            plot.update_xaxes(ticklen = 5, tickwidth = 1, linewidth = 1, mirror = True)
            plot.update_yaxes(ticklen = 5, tickwidth = 1, linewidth = 1, mirror = True)
            plot.update_layout(
                width = 300*1, height = 300*1, 
                font = dict(size=11),
                )

    for plot in [c0_surface, c1_surface, c2_surface, c3_surface]:
        if pub_fig_checkbox.value:
            plot.update_layout(
                width = 300*3.3, height = 300*3.3, 
                font = dict(size=33), # based in 300 dpi
                )
        else:
            plot.update_layout(
                width = 300*1, height = 300*1, 
                font = dict(size=11),
                )
    return (
        c0_contour,
        c0_surface,
        c1_contour,
        c1_surface,
        c2_contour,
        c2_surface,
        c3_contour,
        c3_surface,
        plot,
    )


@app.cell
def _(
    E_a_number,
    E_e_number,
    E_f_number,
    E_i_number,
    PCET_model,
    V_checkbox,
    Vae,
    Vaf,
    Vai,
    Vea,
    Vef,
    Vei,
    Vfa,
    Vfe,
    Vfi,
    Via,
    Vie,
    Vif,
    d_number,
    k_ap_number,
    k_aq_number,
    k_ep_number,
    k_eq_number,
    k_fp_number,
    k_fq_number,
    k_ip_number,
    k_iq_number,
    k_p_checkbox,
    k_q_checkbox,
    np,
    theta_p_number,
    theta_q_number,
):
    # Initialize the PCET model
    myPCET = PCET_model() # need to call it like a function

    # update the d value
    myPCET.d = d_number.value
    myPCET.generate_xy()

    # now update the PCET model object with information from the numbers
    myPCET.q.angle = theta_q_number.value
    myPCET.q.get_unit_vector()

    myPCET.p.angle = theta_p_number.value
    myPCET.p.get_unit_vector(coord = "p")

    myPCET.get_PES_locations()

    # Degrees of coupling and concertedness
    degCoupl = np.cos((theta_q_number.value+theta_p_number.value)/360*2*np.pi)
    degConct = 1-np.tan(theta_p_number.value/360*2*np.pi)

    # Get remaining parameters for uncoupled surfaces, and calculate them
    if k_q_checkbox.value: # so read things symmetrically, from the kqi
        myPCET.i.k.q = k_iq_number.value
        myPCET.e.k.q = k_iq_number.value
        myPCET.a.k.q = k_iq_number.value
        myPCET.f.k.q = k_iq_number.value
    else:
        myPCET.i.k.q = k_iq_number.value
        myPCET.e.k.q = k_eq_number.value
        myPCET.a.k.q = k_aq_number.value
        myPCET.f.k.q = k_fq_number.value


    if k_p_checkbox.value:
        myPCET.i.k.p = k_ip_number.value
        myPCET.e.k.p = k_ip_number.value
        myPCET.a.k.p = k_ip_number.value
        myPCET.f.k.p = k_ip_number.value
    else:
        myPCET.i.k.p = k_ip_number.value
        myPCET.e.k.p = k_ep_number.value
        myPCET.a.k.p = k_ap_number.value
        myPCET.f.k.p = k_fp_number.value

    myPCET.i.energy = E_i_number.value
    myPCET.e.energy = E_e_number.value
    myPCET.a.energy = E_a_number.value
    myPCET.f.energy = E_f_number.value

    myPCET.generate_uncoupled_surface_z()

    # now get values needed for coupled surfaces, and calculate
    if V_checkbox.value:
        myPCET.couplings = np.array([
            [0,         Vie.value, Via.value, Vif.value],
            [Vie.value, 0,         Vea.value, Vef.value],
            [Via.value, Vea.value, 0,         Vaf.value],
            [Vif.value, Vef.value, Vaf.value, 0        ]
        ]) #
    else:
        myPCET.couplings = np.array([
            [   0,      Vei.value, Vai.value, Vfi.value],
            [Vie.value, 0,         Vae.value, Vfe.value],
            [Via.value, Vea.value, 0,         Vfa.value],
            [Vif.value, Vef.value, Vaf.value, 0        ]
        ]) #

    myPCET.generate_coupled_surface_zs()

    surface_plot = myPCET.generate_surface_plot(zs = [myPCET.cs0.z, myPCET.cs1.z, myPCET.cs2.z, myPCET.cs3.z]) 
    contour_plot = myPCET.generate_contour_plot(zs = [myPCET.cs0.z, myPCET.cs1.z, myPCET.cs2.z, myPCET.cs3.z])
    return contour_plot, degConct, degCoupl, myPCET, surface_plot


@app.cell
def _(c3_contour, c3_surface, myPCET, np, z3_cutoff_slider):
    # now plotting updating... separate out so they are not all called all the time.

    scale_buffer = 0.05

    z3_range = np.max(myPCET.cs3.z) - np.min(myPCET.cs3.z)
    z3_scale = np.linspace(np.min(myPCET.cs3.z)-scale_buffer*z3_range, np.max(myPCET.cs3.z)+scale_buffer*z3_range, 101)
    if z3_cutoff_slider.value[0] >= 1:
        z3_min = z3_scale[int(z3_cutoff_slider.value[0])] #
        min_clipped_z3 = np.where(myPCET.cs3.z < z3_min, np.nan, myPCET.cs3.z)
    else:
        min_clipped_z3 = myPCET.cs3.z
    z3_max = z3_scale[int(z3_cutoff_slider.value[1])] #
    clipped_z3 = np.where(myPCET.cs3.z > z3_max, np.nan, min_clipped_z3)

    c3_surface.data[0].z = clipped_z3
    c3_contour.data[0].z = clipped_z3
    return (
        clipped_z3,
        min_clipped_z3,
        scale_buffer,
        z3_max,
        z3_min,
        z3_range,
        z3_scale,
    )


@app.cell
def _(c2_contour, c2_surface, myPCET, np, scale_buffer, z2_cutoff_slider):
    z2_range = np.max(myPCET.cs2.z) - np.min(myPCET.cs2.z)
    z2_scale = np.linspace(np.min(myPCET.cs2.z)-scale_buffer*z2_range, np.max(myPCET.cs2.z)+scale_buffer*z2_range, 101)
    if z2_cutoff_slider.value[0] >= 1:
        z2_min = z2_scale[int(z2_cutoff_slider.value[0])] #
        min_clipped_z2 = np.where(myPCET.cs2.z < z2_min, np.nan, myPCET.cs2.z)
    else:
        min_clipped_z2 = myPCET.cs2.z
    z2_max = z2_scale[int(z2_cutoff_slider.value[1])] #
    clipped_z2 = np.where(myPCET.cs2.z > z2_max, np.nan, min_clipped_z2)

    c2_surface.data[0].z = clipped_z2
    c2_contour.data[0].z = clipped_z2
    return clipped_z2, min_clipped_z2, z2_max, z2_min, z2_range, z2_scale


@app.cell
def _(c1_contour, c1_surface, myPCET, np, scale_buffer, z1_cutoff_slider):
    z1_range = np.max(myPCET.cs1.z) - np.min(myPCET.cs1.z)
    z1_scale = np.linspace(np.min(myPCET.cs1.z)-scale_buffer*z1_range, np.max(myPCET.cs1.z)+scale_buffer*z1_range, 101)
    if z1_cutoff_slider.value[0] >= 1:
        z1_min = z1_scale[int(z1_cutoff_slider.value[0])] #
        min_clipped_z1 = np.where(myPCET.cs1.z < z1_min, np.nan, myPCET.cs1.z)
    else:
        min_clipped_z1 = myPCET.cs1.z
    z1_max = z1_scale[int(z1_cutoff_slider.value[1])] #
    clipped_z1 = np.where(myPCET.cs1.z > z1_max, np.nan, min_clipped_z1)

    c1_surface.data[0].z = clipped_z1
    c1_contour.data[0].z = clipped_z1
    return clipped_z1, min_clipped_z1, z1_max, z1_min, z1_range, z1_scale


@app.cell
def _(c0_contour, c0_surface, myPCET, np, scale_buffer, z0_cutoff_slider):
    z0_range = np.max(myPCET.cs0.z) - np.min(myPCET.cs0.z)
    z0_scale = np.linspace(np.min(myPCET.cs0.z)-scale_buffer*z0_range, np.max(myPCET.cs0.z)+scale_buffer*z0_range, 101)
    if z0_cutoff_slider.value[0] >= 1:
        z0_min = z0_scale[int(z0_cutoff_slider.value[0])] #
        min_clipped_z0 = np.where(myPCET.cs0.z < z0_min, np.nan, myPCET.cs0.z)
    else:
        min_clipped_z0 = myPCET.cs0.z
    z0_max = z0_scale[int(z0_cutoff_slider.value[1])] #
    clipped_z0 = np.where(myPCET.cs0.z > z0_max, np.nan, min_clipped_z0)

    c0_surface.data[0].z = clipped_z0
    c0_contour.data[0].z = clipped_z0
    c0_contour.data[0].contours.end = np.nanmax(clipped_z0) # re-scale the contour plot colors
    c0_contour.data[0].contours.start = np.nanmin(clipped_z0) # re-scale the contour plot colors
    c0_contour.data[0].contours.size = float((np.nanmax(clipped_z0) - np.nanmin(clipped_z0))/25) # re-scale the contour plot colors
    return clipped_z0, min_clipped_z0, z0_max, z0_min, z0_range, z0_scale


@app.cell
def _(
    E_a_number,
    E_e_number,
    E_f_number,
    E_i_number,
    V_checkbox,
    Vae,
    Vaf,
    Vai,
    Vea,
    Vef,
    Vei,
    Vfa,
    Vfe,
    Vfi,
    Via,
    Vie,
    Vif,
    c0_contour,
    c0_surface,
    c1_contour,
    c1_surface,
    c2_contour,
    c2_surface,
    c3_contour,
    c3_surface,
    d_number,
    filename_text_input,
    k_p_checkbox,
    k_q_checkbox,
    kpa,
    kpe,
    kpf,
    kpi,
    kqa,
    kqe,
    kqf,
    kqi,
    mo,
    theta_p_number,
    theta_q_number,
    z0_cutoff_slider,
    z1_cutoff_slider,
    z2_cutoff_slider,
    z3_cutoff_slider,
):
    # export function:
    '''
    Need to export the current view (so cutoffs)
    and also the parameters for EVERYTHING
    and all surface (even if they were not originally shown)
    '''
    import plotly.io as pio

    def export_state_to_HTML ():
        #filename = input("Enter the filename (with extension, e.g., output.txt): ")

        with open(f"{filename_text_input.value}.html", "w", encoding="utf-8") as file:
            file.write(f"""<!DOCTYPE html>
    <html lang="en">
    <head>
        <meta charset="UTF-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <title>{filename_text_input.value}</title>
    </head>
    <body>""")

            file.write(f"""
    <table style="width:100%">
        <tr>
            <td>donor=acceptor={V_checkbox.value}</td>
            <td></td>
            <td>all k<sub>q</sub> equal={k_q_checkbox.value} </td>
            <td>all k<sub>p</sub> equal={k_p_checkbox.value} </td>
        </tr>
        <tr>
            <td>d={d_number.value}</td>
            <td>E<sub>i</sub>={E_i_number.value}</td>
            <td>k<sub>qi</sub>={kqi.value}</td>
            <td>k<sub>pi</sub>={kpi.value}</td>
        </tr>
        <tr>
            <td>theta<sub>q</sub>={theta_q_number.value}</td>
            <td>E<sub>e</sub>={E_e_number.value}</td>
            <td>k<sub>qe</sub>={kqe.value}</td>
            <td>k<sub>pe</sub>={kpe.value}</td>
        </tr>
        <tr>
            <td>theta<sub>p</sub>={theta_p_number.value}</td>
            <td>E<sub>a</sub>={E_a_number.value}</td>
            <td>k<sub>qa</sub>={kqa.value}</td>
            <td>k<sub>pa</sub>={kpa.value}</td>
        </tr>
        <tr>
            <td></td>
            <td>E<sub>f</sub>={E_f_number.value}</td>
            <td>k<sub>qf</sub>={kqf.value}</td>
            <td>k<sub>pf</sub>={kpf.value}</td>
            <td></td>
        </tr>
        <tr>
            <td colspan="4"><hr/></td>
        </tr>
        <tr>
            <td style="text-align: center;">0</td>
            <td>V<sub>ei</sub>={Vei.value}</td>
            <td>V<sub>ai</sub>={Vai.value}</td>
            <td>V<sub>fi</sub>={Vfi.value}</td>
        </tr>
        <tr>
        <td>V<sub>ie</sub>={Vie.value}</td>
            <td style="text-align: center;">0</td>
            <td>V<sub>ae</sub>={Vae.value}</td>
            <td>V<sub>fe</sub>={Vfe.value}</td>
        </tr>
        <tr>
            <td>V<sub>ia</sub>={Via.value}</td>
            <td>V<sub>ea</sub>={Vea.value}</td>
            <td style="text-align: center;">0</td>
            <td>V<sub>fa</sub>={Vfa.value}</td>
        </tr>
            <tr>
            <td>V<sub>if</sub>={Vif.value}</td>
            <td>V<sub>ef</sub>={Vef.value}</td>
            <td>V<sub>af</sub>={Vaf.value}</td>
            <td style="text-align: center;">0</td>
        </tr>
        <tr>
            <td colspan="4"><hr/></td>
        </tr>
        </table>

    <table style="width:100%">
      <tr>
      <td> Surface </td>
      <td></td>
      <td></td>
      <td> Z-scale slider</td>
      </tr>
        <tr>
          <td></td>
          <td>{pio.to_html(c3_surface)}</td>
          <td>{pio.to_html(c3_contour)}</td>
          <td>c3 cufoffs{z3_cutoff_slider.value}</td>
        </tr>
        <tr>
          <td></td>
          <td>{pio.to_html(c2_surface)}</td>
          <td>{pio.to_html(c2_contour)}</td>
          <td>c2 cutoffs={z2_cutoff_slider.value}</td>
        </tr>
        <tr>
          <td></td>
          <td>{pio.to_html(c1_surface)}</td>
          <td>{pio.to_html(c1_contour)}</td>
          <td>c1 cutoffs={z1_cutoff_slider.value}</td>
        </tr>
        <tr>
          <td></td>
          <td>{pio.to_html(c0_surface, full_html=False)}</td>
          <td>{pio.to_html(c0_contour, full_html=False)}</td>
          <td>c0 cutoffs={z0_cutoff_slider.value}</td>
        </tr>
    </table>  
    """)

            file.write("""
    </body>
    </html>
    """)
        return
    export_button = mo.ui.button(
        on_click=export_state_to_HTML(),
        label="export state as HTML", kind="warn"
    )
    return export_button, export_state_to_HTML, pio


@app.cell
def _():
    return


@app.cell
def import_state_from_HTML():
    # import fuction

    def import_state_from_HTML ():
        return
    return (import_state_from_HTML,)


@app.cell
def _():
    return


if __name__ == "__main__":
    app.run()
