## How to run with Marimo

You need to have Marimo (https://marimo.io/) installed, via pip or whatever package manager you are using.

In the terminal, navigate to the folder that has the marimo notebook (`DynamicAvocados.py`)

If you want to run the notebook, you can use:
```
marimo run DynamicAvocados.py
```
If you want to also edit and run the notebook, you can use:
```
marimo edit DynamicAvocados.py
```

You need to have your terminal active in the same directory as the notebook, since the notebook uses the PCETmodel.py as an external module, and this will only work if it is in the working directory. Additionaly, you will need `numpy` and `plotly` packages. 

## How to run with `uv`

You will need `uv` package manager, which can be downloaded at https://docs.astral.sh/uv/.

### Option 1: Creating a virtual environment
Navigate yourself in the terminal to the directory with `DynamicAvocados.py`. There, you can create a virtual environment (called `pcet`) and run the notebook within this environment.
```
uv venv pcet  
source pcet/bin/activate  
uv pip install numpy marimo plotly  
marimo run DynamicAvocados.py  
```
If you wish to run the notebook again, you will only need to activate the virtutal environment:
```
source pcet/bin/activate 
marimo run DynamicAvocados.py
```

### Option 2: Running the notebook in a self-contained environment
Simply execute:
```
uv run --with marimo --with numpy --with plotly marimo run DynamicAvocados.py
```